Page MenuHomePhabricator

[Intervention] Manual topic subscriptions
Open, Needs TriagePublic

Description

This task represents the work involved with increasing peoples' awareness of things others say in conversations they are interested in by offering a new feature for electing to be notified about new comments in specific sections people have chosen to subscribe to.

More details below.

Objective and theory of change

Objective
This work is intended to increase the likelihood Junior and Senior Contributors receive timely and relevant responses to the things they say.

Theory of change
We think that:

  • If people are able to be more specific in deciding the new comments they are and are not notified about...
  • ...then they will be able to more easily and quickly identify comments requiring a response...
  • ...and be more likely to respond to those comments in a timely manner.

User stories

Primary stories
As a Senior Contributor who is watching many pages across Wikipedia namespaces, I want to be made aware when another person adds a new comment in a conversation I am interested in, so that I can decide whether it is necessary/worthwhile for me to respond.

As a Senior Contributor who is interested in a particular conversation that is happening on a busy talk page, I want to be made aware when another person adds a new comment in said conversation, so that I can decide whether it is necessary/worthwhile for me to respond.

Secondary stories
As a Junior Contributor who is interested in a particular conversation that is happening on a talk page, I want to be made aware when another person adds a new comment in said conversation, so that I can follow how the conversation unfolds.

Background

Challenges

  • On pages that have many active threads[i], people have a difficult time staying up-to-date about the specific conversations they are interested in.
    • "...pertinent changes to sections that interest me get superseded by subsequent changes to other sections." | Source: meta.wiki
  • On pages that have a few active threads [i], people can miss out on comments posted in other, less active, sections.
    • " Sometimes the movement of the terrace is very large, and times when only one or two topics account for almost all editions on the terrace. When this happens editions in other topics may go unnoticed among others, then we don't even see that there are new comments, sometimes we don't even see that there is a new topic" | Source: pt.wiki

Implications

  • People risk missing important information about their wiki work
  • People risk not responding to others who would value their input

The risks above are especially important for they threaten a core promise people depend on talk pages to fulfill: to facilitate interactions with other people. Said another way: if people understand talk pages as places to talk with other people and those "other people" don't respond in a timely manner, the people seeking contact with others will lose faith in and stop using talk pages.

Requirements

Meta

  • Platforms: mobile and desktop
  • Editing interfaces: should be able to be notified about "qualifying comments" regardless of the editing interface used to publish them. Said another way: whether someone posted a comment using the Reply Tool or full-page wikitext editing should *not* affect the notification said comment triggers.

Being made aware functionality exists

  • Upon landing on a talk page that contains at least one "qualifying section," people should know it is possible to subscribe to receive notifications about new comments posted to them and how to go about doing this.

Initiating subscriptions

  • People should be able to subscribe to be notified about "qualifying comments" posted in any "qualifying sections" on the page.
  • The first time people subscribe to a "qualifying section," they should understand the following:
    • What the action they just took means for them. Read: when other people post new comments to this topic, the person subscribing will be notified.
    • They have the ability to control how they receive these notifications and how to exercise this control. Read: visit Special:Preferences#mw-prefsection-echo
  • Upon subscribing to receive notifications about new comments about a topic, people should be able to quickly scan the page and identify the topics they are and are not currently subscribed to receive notifications about.

Qualifying sections

  • People should be able to elect to be notified about qualifying comments in sections that meet any of the following conditions:
    • The section exists on a page in a talk namespace
    • The section exists on a page where __NEWSECTIONLINK__ is present (T245890)
  • The section starts with an ==H2 heading

Qualifying comments

  • Comments that meet the conditions below should cause people who have subscribed to that topic to receive notifications in the way(s) they've elected to in Special:Preferences#mw-prefsection-echo:
    • The comment was posted at any point after people subscribed to the topic
    • The comment was published by someone other than the person who subscribed to the topic.

Notification delivery/receipt

  • Notifications about new comments in sections people are subscribed to should appear in Notices.
  • By default, notifications about new comments in sections people are subscribed to should be delivered through the same channels (e.g. Web/Apps/Email) people have elected to receive notifications for Talk page message.
    • Said another way: the new event this work will introduce to the table within Special:Preferences#mw-prefsection-echo should copy over the same default settings from those which people have set for the existing Talk page message event.
  • People should be able to elect to receive topic subscription notifications on all of the platforms they may be contributing (web, iOS and Android).
    • Note: people receiving notifications on the apps depends on them supporting Echo.

Notification contents

  • The topic subscription notifications people receive should equip them with all of the information/context they will need to know what – if any – action they need to take as a result of having received the notification. Example components listed below...
    • What the notification is.
      • E.g.: a new comment in a topic you are subscribed to.
    • Where the notification comes from.
      • E.g. the title of the topic the comment was added to and the title of the page on which that topic exists.
    • Why the recipient is being notified.
      • E.g. They are subscribed to this topic.
    • Who wrote the comment the person is being notified about.
    • When the comment they were being notified about was written.
    • A snippet of the coment they are being notified about

Notification actions

  • The topic subscription notifications people receive should enable them to take the following actions:
    • View the comment they are being notified about in context
      • For the purpose of this task, after clicking a notification, people should be taken to the section in which the comment they are being notified exists.
      • Note: The work required to take people to the EXACT location on a talk page where the comment they are being notified appears will happen in T253082 and before that, T273072.
    • Reply to the comment they are being notified about
      • #TODO: what happens for people who don't have the Reply Tool enabled?
    • Turn off notifications for the section the specific notification "belongs" to
    • Mark a notification as "read"
    • Learn about the author of the comment they are being notified about

Notification management

  • People should be able to control the channel through which notifications about topics they are subscribed to are delivered. E.g. "Web," "Email," and "Apps".

Subscription management

  • [LATER] People should be able to see all of the topics they are subscribed to in one location. Withi this same view, people should be able to turn on/off subscriptions to individual topics within this list. See: T273342.

Open questions

  • 12. What approach should we take for assigning topics and comments unique identifiers?
  • 1. Can we ensure topic subscription notifications be delivered via the apps?
    • If the apps support Echo, yes. If not, no.
  • 2. How might topic subscriptions get implemented on the apps?
    • Editors using the iOS or Android app, who have Apps notification delivery enabled in Special:Preferences#mw-prefsection-echo will receive all new Echo notifications the Editing Team introduces. Reason: the Android and iOS apps depend on Echo to deliver app users notifications.
    • Considering the iOS app currently shows people mobile web talk pages, the Editing Team can assume iOS app users will be able to subscribe to topics from within the iOS app. We'll need to revisit this assumption later this summer when the iOS team begins working on implementing talk pages natively on iOS.
    • Considering the Android app currently uses a native implementation of talk pages, the Editing Team should NOT assume Android app users will be able to subscribe to topics from within the app
  • 3. What should happen to the watch this page checkbox within the Reply and New Discussion Tools?
    • For now, it will remain unchanged. If/when this becomes problematic, we will revisit this decision. More in: T273911#6882727.
  • 4. How – if at all – does peoples' use of the Reply Tool and New Discussion Tool affect topic subscriptions?
    • For now, we are going to limit the scope of this task to "explicit" topic subscriptions. We will consider "implicit" topic subscriptions in T263819.
  • 5. How – if at all – should topic subscriptions consider/relate to temporary watchlisting?
    • Considering we are currently thinking that topic subscription updates will be delivered via Echo rather than via Watchlists, we do not see there being a relationship to temporary watchlisting.
  • 8, If necessary, would it be possible for people to elect to have topic subscription updates published to their Watchlist?
    • For now, new comment notifications will not be explicitly "published" within peoples' Watchlists. We will revisit this decision if/when it becomes necessary.
  • 10. When and how should topic subscriptions get rolled out on mobile? E.g. Should the feature, initially, be offered in both the mobile overlay and Read as wiki page view?
    • As discussed during the team's 4-March standup, we are going to design for the "Read as wiki page` view.
  • 6. What happens if a topic you are subscribed to gets renamed?
    • Per the conversation @Esanders and I had on 26-Jan-2021, we are going to defer answering this question until it becomes an issue. If/when we do address this scenario, we will think through it in T262991.
  • 7. What happens if a specific section you are watching gets moved?
    • Per the conversation @Esanders and I had on 26-Jan-2021, we are going to defer answering this question until it becomes an issue. If/when we do address this scenario, we will think through it in T262990.
  • 9. How – if at all – should people watching talk pages affect whether they are notified when a new topic is added?
    • This will be decided on in T263821.
  • 11. What actions should people be able to take from the new comment notifications that will appear in the Notice tray/drawer?
    • This will be decided on in T273911.

Done

  • All ===Open questions are addressed
  • Mockups are created that fulfill the ===Requirements above.

References

The above is built on valuable thinking and talking that has happened in the past. Links to *some* of this research and conversations are listed below. If you can think of more, please boldly add it here and post a comment alerting us that you've done so.


i. E.g.: AfD (en.wiki), Tearoom (en.wikitionary), Village pump (ru.wiki), user pages (e.g. User:WhatamIdoing), wp:ANI (en.wiki), wp:Reference desk (en.wiki), WP:ERRORS, Wikipedia:AN, Wikipedia:Village pump (technical), Teahouse

Related Objects

StatusSubtypeAssignedTask
OpenNone
Openppelberg
OpenNone
Resolved LZaman
Resolved iamjessklein
DuplicateNone
ResolvedJTannerWMF
ResolvedEsanders
Resolvedppelberg
Resolvedppelberg
Resolved iamjessklein
ResolvedMNeisler
Resolvedppelberg
Resolvedmatmarex
Resolvedmatmarex
ResolvedEsanders
Resolvedmatmarex
Resolvedmatmarex
ResolvedRyasmeen
ResolvedEsanders
Resolvedppelberg
ResolvedEsanders
Resolvedmatmarex
ResolvedUrbanecm
DuplicateNone
Resolvedppelberg
DuplicateNone
ResolvedRyasmeen
Resolvedmatmarex
ResolvedWhatamidoing-WMF
Resolvedppelberg
Resolved iamjessklein
Resolvedmatmarex
Resolvedmatmarex
Resolvedppelberg
Resolved iamjessklein
Resolved iamjessklein
ResolvedEsanders
ResolvedEsanders
Resolvedppelberg
Resolvedppelberg
Resolvedmatmarex
Resolvedppelberg
Resolvedmatmarex
ResolvedRyasmeen
Resolvedmatmarex
Resolvedmatmarex
Resolvedppelberg
Resolvedppelberg
OpenNone
DuplicateNone
InvalidNone

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes
ppelberg renamed this task from Ensure people are aware when something new is said in a conversation they are following to Use case #2: Ensure people are aware when something new is said in a conversation they are following.Oct 2 2020, 7:25 PM
ppelberg renamed this task from Use case #2: Ensure people are aware when something new is said in a conversation they are following to Use case #2: Subscribing to sections.Jan 16 2021, 12:05 AM
ppelberg updated the task description. (Show Details)

META
I've updated the task description with a rough outline of the requirements and background information. I will have the full requirements posted in the next ~2 weeks.

Update 22-Jan
I've updated the task description with a sketch of the initial requirements.

ppelberg renamed this task from Use case #2: Subscribing to sections to Use case #2: Subscribing to topics.Jan 23 2021, 2:33 AM
  • 3. What should happen to the watch this page checkbox within the Reply and New Discussion Tools?

I’d like to have it kept. Senior users like me may not want to make use of this new subscription feature but keep using the watchlist. Also, visually there should be no conflict, since subscription is aimed at junior contributors as well, so if it gets a checkbox in the reply/new discussion UI, it should not be in the “advanced” part.

A note from today's conversation with @iamjessklein:

  • Jess flagged the potential need for any design around iOS and Android to be considered separate from the initial web implementation.

Resulting action

  • @ppelberg to talk with Android and iOS teams about how this work could impact the apps.

On 26-January, @Esanders and I met to talk through the ===Requirements and ===Open questions.

I've updated the task description to reflect the outcomes of that conversation. You can view the exact changes in this diff.

ppelberg renamed this task from Use case #2: Subscribing to topics to [Intervention] Topic subscriptions.Feb 8 2021, 8:46 PM
ppelberg updated the task description. (Show Details)

Update: 8-February
I've updated the task description's Open questions section with the answers that have surfaced in our team's conversations over the past couple of weeks.

One of the suggested actions in the spec above is "Reply to the comment they are being notified about"

This is the only action for which we don't have precedent. The only other notification that could do this are flow-reply notifications, and they don't. As we can only show a snippet of the comment in the notification, perhaps the thinking is that we want people to read the full message before replying. A counter example is the quick-reply functionality that you can with most mobile apps these days.

The other thing we need to decide is if we want a secondary action after the user link, and if we do, what it should be. In flow-reply notifications this is a link to the board, and in mention notifications it is a link to the diff ("View changes"). It could be either of these, or the reply action discussed above. In general there is room for two secondary actions, and extra ones go in the dropdown menu.

Flow-reply notification:

image.png (117×526 px, 17 KB)

Mention notification:

image.png (138×485 px, 18 KB)

  1. ADDED the question Ed posed in T263820#6858937 to the task description's Open questions section. See question #11.
  2. DOCUMENTED the outcomes of the conversations we had this morning about the potential actions people could take from new comment notifications.

Actions people could take from/on the new comment notification they are receiving
Below is a list of the potential actions people could take from the new comment notifications that will appear in the Notice tray/drawer.

  • Visit the talk page on which the new comment was posted
  • Visit the talk page on which the new comment was posted and be taken to the topic where the new comment was posted
  • Visit the talk page on which the new comment was posted and be taken to the specific comment people are being notified about
    • Consideration: the above is currently only possible for people who have the Reply Tool enabled. To remove this dependency, T267404 and T273072 must first be resolved.
  • Visit the diff of the edit(s) that led the person to receive the new comment notification
  • Reply to the comment they are being notified about
    • Consideration: as Ed shared above, no design pattern currently exists for supporting this kind "in context comment"
  • Send a "Thanks" notification to the author of the new comment people are being notified about
    • Considerations: because "Thanks" are sent on a per-diff basis and new comment notifications may NOT be mapped directly to diffs, there could be a situation where someone sends a "Thanks" to someone other than the author of the comment they are being notified about.
      • 1) "Person A" posts "Comment 1" without signing it.
      • 2) "Person B" adds a signature to "Comment 1"
      • 3) A new comment notification to be sent to "Person C"
      • 4) "Person C" sends a "Thanks" to, who they think is, the author of "Comment 1"
      • 5) "Peron B" receives a "Thanks" from "Person C"

EDIT: based on what @Esanders shared with me on 2-March, I'm striking through the dependencies on T267404 and T273072.

ppelberg added subscribers: JTannerWMF, JMinor.

Open questions

  • 2. How might topic subscriptions get implemented on the apps?

Added the outcomes from the conversation @JTannerWMF, @JMinor and I had offline as answers to the open question above within the task description.

ppelberg renamed this task from [Intervention] Topic subscriptions to [Intervention] Manual topic subscriptions.Apr 22 2021, 12:58 AM